package info.textgrid.lab.collatex.model;

import info.textgrid.lab.collatex.model.equivalences.Equivalences;

import java.net.URI;
import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * A list of witnesses to be collated, plus collation settings affecting all
 * those witnesses.
 */
@XmlRootElement
public class CollationSet {

	static final String NAMESPACE = "http://textgrid.info/namespaces/collation/collationSet"; //$NON-NLS-1$

	private List<CollationSetWitness> witnesses;

	private URI regularisation;

	/**
	 * The witnesses to be collated.
	 */
	@XmlElement(name="witness")
	public List<CollationSetWitness> getWitnesses() {
		if (witnesses == null)
			witnesses = new ArrayList<CollationSetWitness>();
		return witnesses;
	}

	/**
	 * The URI of the regularisation object. The object referenced by this URI
	 * should contain the XML representation of an {@link Equivalences} data
	 * structure.
	 */
	public URI getRegularisation() {
		return regularisation;
	}

	public void setRegularisation(final URI regularisation) {
		this.regularisation = regularisation;
	}

}
